/*
  JSgui/filefox.js (c) 2008-2009 whygee@f-cpu.org
  created 2009-05-29 from various previous prototypes
  version 2009-05-31
  version 2009-07-07 : moved to JSgui

Based on an article published in GNU/Linux Magazine France
and written by myself. Many enhancements have been included.

For the backup of JS data to the local disk, 2 methods are implemented :
 - "save as open window" (simple but not very practical)
 - loopback with PHP (better but more complex)
Note that the loopback is deactivated on yasep.org
but you can add one on your local machine.
It's easy under Linux, just install the Apache and PHP packages.
It's even easier on Windows with EasyPHP !

note : the semaphore should be moved to the form's object.
*/

// Various DOM objects for the input/output of informations
var FF_msg_id;
var FF_adr_id;
var FF_iframe_id;
var FF_save_with_loopback_id;

// should be replaced by something more suitable for the interface.
function FF_message(color, text) {
  FF_msg_id.innerHTML = '<font color="'+color+'">'+text+'</font>';
}

///////////////////////////////////////////////////////////////////
//  Export to file / Save to disk
///////////////////////////////////////////////////////////////////

// Save the contents to a pop-up window,
// whose contents must be cut-pasted
// by the user to the desired file.

var saveWin=null; // container of the created pop-up window

function save_to_screen(data) {
  data=data.replace("<","&lt;");

// Characters with accents (ASCII code > 126)
// should also be replaced, but YASEP doesn't use them (AFAIK)

  // Close the window if it is already open
  if (saveWin != null)
    saveWin.close();

  // create the new window
  saveWin = window.open("", "", "menubar=yes,width=300,height=300");

  // commit the data to the new window
  saveWin.document.write("<pre>"+data+"</pre>");
  saveWin.document.close();
} 


// method with a PHP loopback :
// (new version with semaphores and other blinky stuff)

// address of the loopback server :
var target_loopback;
var FF_semaphore=0;
var FF_form=null;
var FF_old_action="";
var save_with_loopback = true;

function FF_getSemaphore() {
  if (FF_semaphore==0)
    document.body.style.cursor="wait";
  FF_semaphore++;
}

function FF_releaseSemaphore() {
  FF_semaphore--;
  if (FF_semaphore==0)
    document.body.style.cursor="default";
}

// Asynchronous detection :
function probe_server(up, down) {
  try{
    var XHR = new XMLHttpRequest();
    XHR.open("POST",target_loopback, true);
    XHR.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    XHR.onreadystatechange=function() {
      if (XHR.readyState==4) {
        try{
          if ((XHR.status == 200) // HTTP OK 
           && (XHR.responseText == "signaturemagique"))
            up();
          else
            down();
        }
        catch(err) {
          down();
        }
      }
    }
    XHR.send("probe=yakekin");
  }
  catch(err) {
    down();
  }
}

// Callback if success
function server_is_up() {
  FF_old_action=FF_form.action; // backup
    FF_form.action=target_loopback;
    FF_form.submit();
  setTimeout(function(){ FF_form.action=FF_old_action; },100); // restore
  FF_releaseSemaphore();
}

// Callback if failure
function server_is_down() {
  FF_message("red", target_loopback+" is unreachable")
  FF_releaseSemaphore();

  // no server ? then use the archaic method
  disable_loopback();
  alert("No loopback server was found so the fallback method is used.\n"
       +"This method will be used from now on, until you select the loopback method again.\n"
       +"Please press CTRL+S to save the contents of the window that will appear.\n"
       +"*BEWARE* Save under a different file name and with the proper type  !");
  save_to_screen(FF_form.filecontents.value);
}

// This is the entry point for the form :
function save_to_disk(form){
  if (save_with_loopback==true) {
    if (FF_semaphore!=0)
      FF_message("orange", "File operation not complete, please try again later.")
    else {
      FF_getSemaphore();
      FF_form=form;
      probe_server(server_is_up, server_is_down);
    }
  }
  else
    save_to_screen(form.filecontents.value);
}


// These function generate HTML code for the forms
function make_FF_form(formname, filename, columns, lines) {
  if (!lines) lines='7';
  if (!columns) columns='50';
  var m='<p><form method="post" name="form_post" id="'+formname+'"'
       +' action="javascript:save_to_disk(document.'+formname+');" target="filefox_target" >';
  if (filename)
    m+='<input type="hidden" name="filename" id="filename" value="'+filename+'">';
  else
    m+='Name of the file that will be saved : <input type="text" size="30"'
     +' name="filename" id="filename" value="filename">';
  m+='<br><textarea style="display:block" rows="'+lines+'" cols="'+columns+'" scrollbar="auto"'
   +' name="filecontents" id="filecontents"></textarea></form>\n'
   +'<input type="submit" value="Save';
   if (filename)
     m+=' as '+filename;
 m+='" onclick="save_to_disk(document.'+formname+')"> &nbsp;'
   +'<input type="submit" value="Show/hide data" onclick="a=document.'+formname
   +'.filecontents.style; if (a.display==\'none\') a.display=\'block\'; else a.display=\'none\';"></p>';
  return m;
}

function make_FF_ctl() {
  var m='<p>Use PHP loopback'
  +'<input id="check_save_method" type="checkbox" onclick="set_save_with_loopback(this.checked);"><br>'
  +'Loopback address : <input type="text" size="40" name="loopback_address" id="loopback_address" onchange="update_loopback_address(this.value);">'
  +'<input id="submit_server" type="submit" value="change" onclick="update_loopback_address(document.loopback_address.value);">'
  +'<div id="status_div"></div>'
  +'<iframe name="filefox_target" id="filefox_target" style="display:none"></iframe></p>';
  return m;
}


///////////////////////////////////////////////////////////////////
//  Import from file or another web site
///////////////////////////////////////////////////////////////////









///////////////////////////////////////////////////////////////////
// cookie settings / configuration / management
///////////////////////////////////////////////////////////////////

//var loopback_server_list = new Array(); // will be populated later

function disable_loopback() {
  save_with_loopback = false;
  FF_save_with_loopback_id.checked=false;
  // update_cookie
}

function probe_failure() {
  disable_loopback();
  FF_message('red',target_loopback+' is unreachable');
}

function enable_loopback() {
  save_with_loopback = true;
  FF_save_with_loopback_id.checked=true;
  // update_cookie
}

function probe_success() {
  enable_loopback();
  FF_message('green',target_loopback+' is OK');
}

function set_save_with_loopback(val) {
  if (val==true) {
    // test the loopback server
    probe_server(probe_success, probe_failure);
  }
  else
    disable_loopback();
}

function update_loopback_address(adr) {
  target_loopback=adr;
  FF_adr_id.value=adr;

  // PHP loopback only works with HTTP
  if (target_loopback.substring(0,7)=="http://")
    set_save_with_loopback(true);
  else {
    disable_loopback();
    FF_message('orange','notice : Loopback can only work with "http://" addresses');
  }
}

function FF_init() {
  // IDs
  FF_save_with_loopback_id=document.getElementById('check_save_method');
  FF_msg_id = document.getElementById("status_div");
  FF_adr_id = document.getElementById("loopback_address");
  FF_iframe_id = document.getElementById("filefox_target");

  // read the cookies here

  // declare the absolute path to loopback.php
  var p=new String(document.location);
  p=p.substring(0, p.lastIndexOf("/")+1 );

  // check if the field has been preserved by the browser through a page reload
  if(FF_adr_id.value=="")
    // if no previous address, provide a default loopback
    update_loopback_address(p+prfx+"JSgui/loopback.php");
  else
    update_loopback_address(FF_adr_id.value);
    
// note : prfx can be set after this file is parsed. Just run FF_init() in body.onload()
}

// manage a list of loopback servers ??
