-- speed_IE.vhd
-- Version 20090102 by whygee@f-cpu.org

library IEEE;
use ieee.std_logic_1164.all;

entity speed_IE is
  generic (
    YASEP_SIZE : integer := 16 -- either 16 or 32
  );
  port(
    DataA, DataB : in std_logic_vector(YASEP_SIZE-1 downto 0);
    Clk, Load, SignExt, OffsetA : in std_logic;

    ResultIE : out std_logic_vector(YASEP_SIZE-1 downto 0)
  );
end speed_IE;

architecture speed of speed_IE is
  signal DataAr, DataBr : std_logic_vector(YASEP_SIZE-1 downto 0);
  signal Loadr, SignExtr, OffsetAr : std_logic;
  signal ResultIEr : std_logic_vector(YASEP_SIZE-1 downto 0);
begin

  IE:
    entity work.IE_16(second)
    generic map(
      YASEP_SIZE => YASEP_SIZE
    )
    port map(
      DataA    => DataAr,
      DataB    => DataBr,
      Load     => Loadr,
      SignExt  => SignExtr,
      OffsetA  => OffsetAr,

      ResultIE => ResultIEr
    );

  process(Clk, DataA, DataB, Load, SignExt, OffsetA, ResultIEr)
  begin
    if (clk'event and clk='1') then
      DataAr   <= DataA;
      DataBr   <= DataB;
      Loadr    <= Load;
      SignExtr <= SignExt;
      OffsetAr <= OffsetA;

      ResultIE <= ResultIEr;
    end if;
  end process;

end speed;