/*
    VSP/vsp_arch.js
    created Sat Mar  5 23:33:09 EST 2005 by whygee@f-cpu.org

 This is some kind of "include" file that defines the architectural
features and the constants for the rest of the page, so it must be
"read" before any other javascript.

  version Wed Mar  9 18:41:30 EST 2005 : Object-Oriented re-shaping of the code
     in order to clean it as much as possible.

  version Wed Jun  8 20:38:45 EDT 2005 : adding memory
  2 days later : moving memory to vsp_mem.js
  and the registers to vsp_reg.js

  version 2005-06-15 : updating the message queue's code
   and fixed int2hex
  version 2005-06-17 : message queue now looking much better
   and int2hex is re-fixed
  version 2005-06-19 : colors added to the messages
*/


////////////////////////////////////////////////////////

var cycle_number = 0;
var debug = null;  // might be used in certain circumstances ...

////////////////////////////////////////////////////////

// Used for the int <-> hex conversions

var hex_array=new Array(
 "0", "1", "2", "3", "4", "5", "6", "7",
 "8", "9", "A", "B", "C", "D", "E", "F"
);

var int_array=new Array;
int_array["0"] = 0;
int_array["1"] = 1;
int_array["2"] = 2;
int_array["3"] = 3;
int_array["4"] = 4;
int_array["5"] = 5;
int_array["6"] = 6;
int_array["7"] = 7;
int_array["8"] = 8;
int_array["9"] = 9;
int_array["A"] = 10;
int_array["B"] = 11;
int_array["C"] = 12;
int_array["D"] = 13;
int_array["E"] = 14;
int_array["F"] = 15;
int_array["a"] = 10;
int_array["b"] = 11;
int_array["c"] = 12;
int_array["d"] = 13;
int_array["e"] = 14;
int_array["f"] = 15;

function int2hex(value) {
  var tmp;
  var i = 7; // max number of char
  var b = 'u';

  if (value != null) { // null is used to mean "uninitialised"
    if ((typeof value == 'number') && (isFinite(value))) {
      b='';
      tmp = value;
      do {
         // beware of the trap here :
         // ints are always signed, so >> might create troubles.
        b = hex_array[tmp & 15] + b;
        tmp >>= 4;
        i--;
        if (tmp == 0)
          return b;
      } while (i >= 0);
    }
    else
      b = "????????";
  }

  return b;
}

////////////////////////////////////////////////////////

// small FIFO for the message history
var msg_number=1;
var msg_list_depth = 50;
var msg_list = new Array(); // pre-init to prevent problems during real init

function reset_messages() {
  msg_list = new Array(); // flush
  msg_number=1;
}

function add_message(color, msg) {
// color : severity of the message (blue, green, yellow, orange, red ...)
// message : displayed text

  var total = '';
  var i=0;
  var j=0;

  var tmp= '<span style="background-color:' + color + '">' + msg_number + '</span>: ' + msg + '<br>';
  msg_number++;

// this version of the code is longer but more efficient :
// it merges the message accumulation with the shifting loop.
  if (msg_list.length < msg_list_depth) {
    // not enough data to spill, no shift version :
    while (i < msg_list.length) {
      total = msg_list[i] + total;
      i++;
    }
  }
  else {
    // FIFO is now full, we have to remove the oldest entry :
    while (i < (msg_list.length-1)) {
      total = msg_list[i] + total;
      j = i+1;
      msg_list[i] = msg_list[j]; // shift !
      i = j;
    }
  }
  msg_list[i] = tmp; // add the latest message to the queue
  messages.innerHTML = tmp + total;  // and to the output string.
}
