/*
    VSP/vsp_mem.js
    created Fri Mar 25 19:07:11 EST 2005 by whygee@f-cpu.org
    version 2005-06-11 : dplacement du code vers ici

    This file manages the "memory" array : definitions, creation, updates ...

*/

////////////////////////////////////////////////////////

// memory line parameters


// memory array parameters
const mem_lines=128;
const mem_colns=8;
const mem_size=mem_colns*mem_lines;
const mem_bytes=mem_size*4;

var memory_array=new Array();
var memory_id=new Array();

function read_memory(index) { // address in BYTES
  if (index >= mem_bytes) {
    add_message('red', index+' is an invalid address.');
    return null;
  }
  else
    if (index & 3)
      add_message('orange', 'read('+int2hex(index)+'): not a word-aligned address.');
    return memory_array[index>>2];
}

function display_memory(index) { // index in BYTES
// if index is omitted, the whole display is updated.
  var b;
  if (index) {
    if (index & 3)
      add_message('orange', 'display_memory('+int2hex(index)+'): not a word-aligned address.');
    memory_id[index>>2].innerHTML=int2hex(read_memory(index));
  }
  else {
    for (b=0; b<mem_size; b++)
      memory_id[b].innerHTML=int2hex(memory_array[b]);
  }
}

function reset_memory() { 
  var i;
  memory_array = new Array();
/*
  display_memory();
  for (i=0; i<mem_size; i++)
    memory_id[i].innerHTML='u';
*/
}

function update_memory(index, data) { // address in BYTES
  if (index >= mem_bytes) {
    add_message('red', index+' is not a valid address.');
  }
  else {
    if (isNaN(data)) {
      add_message('red', data+' is not a valid number.');
    }
    else {
      if (index & 3)
        add_message('orange', 'update_memory('+int2hex(index)+'): not a word-aligned address.');
      var adr=index>>2;
      if (memory_array[adr]!=data) {
        memory_array[adr]=data;
        memory_id[adr].innerHTML=int2hex(data); //display_memory()...
      }
    }
  }
}

function cycle_memory() { 

}