/* js_segment.js
 cr le 10 novembre 2006 par whygee@f-cpu.org
 version 2006-11-16
 version 2006-12-27 : split into different files
*/


// segments de bas en haut ?
var debasenhaut=true;
var dehautenbas=true;

/* segment display (when drawing) */
var segment_inside_id, segment_outside_id, segment_id_orig; /* globals for drawing segments */
var segname, segname_id; /* global used when moving the label */
var origSegmentColor="#2222FF", SegmentDrawingColor="#66FF99", SegmentWidth=2;
var SegmentPrefix="seg", CurrentSegmentNumber=1;
var curSeg, last_seg=0;
var SegnameMargin=9;

/* internal metadatabase */
var segment_list=new Array();
var reverse_seglist=new Array();


function display_segment(nr,bypass) {
  var s=segment_list[nr];

  s.active=1;
  itembar_div_id.insertBefore(s.itembar_id,itembar_first_id);
  itembar_first_id=s.itembar_id;

  if (bypass)
    return;
  segment_inside_id.appendChild(s.id);
  segment_inside_id.appendChild(s.segname_id);
}

function hide_segment(nr) {
  var s=segment_list[nr];

  s.active=0;
  segment_inside_id.removeChild(s.id);

  var t=s.itembar_id;
  if(itembar_first_id==t)
     itembar_first_id=t.nextSibling;
  itembar_div_id.removeChild(t);

  segment_inside_id.removeChild(s.segname_id);
}


/* some easy eye candy */

function segment_focus(a) {
  a.id.style.zIndex=2;
  a.idN.style.borderColor="#FF6666";
  a.idS.style.borderColor="#FF6666";
  a.itembar_id.style.backgroundColor="#E0C0C0";
  a.seglist_a.focus();
}

function segment_blur(a) {
  a.id.style.zIndex=1;
  a.idN.style.borderColor=a.SegmentColor;
  a.idS.style.borderColor=a.SegmentColor;
  a.itembar_id.style.backgroundColor="#E0D0D0";
}

function segment_mouseover(ev){
  var t=name_lookup(ev.target.id);
  if ((mouse_status==mouse_off)&&(t!=null)&&(segment_list[t])) {
    var a=segment_list[t];
    if (ev.type=="mouseover")
      segment_focus(a);
    else
      segment_blur(a);
  }
  return false;
}


/* move of a segment's middle bar */

function stopmove_segmentratio(ev) {
/*
  if (ev) {
  }
*/
  segment_blur(segname);

  segment_inside_id.onmousemove=null;
  segment_inside_id.onmouseup=null;
  mouse_status = mouse_off;
  ev.cancelBubble=true;
  return false;
}

function mousemove_segmentratio(ev) {
  var y=ev.pageY-div_menubar_height;

  if (segname.Yend<segname.Yinit) {
    var Yi=segname.Yend;
    var Ye=segname.Yinit;
  }
  else {
    var Yi=segname.Yinit;
    var Ye=segname.Yend;
  }

  if ((y>(Yi+SegnameMargin))
    &&(y<(Ye-SegnameMargin))) {
    segname.topN=y-Yi;
    segname_id.style.top=y-20;
    segname.idN.style.height=segname.topN;
  }

  ev.cancelBubble=true;
  return false;
}

function startmove_segmentratio(ev){
  if (mouse_status == mouse_off) {
    var t=name_lookup(ev.target.id);
    if ((t!=null)&&(segment_list[t])) {
      segname=segment_list[t];
      segname_id=segname.segname_id;

      mouse_yoffset = ev.pageY-div_menubar_height;

      segname.topN=3;

      segment_inside_id.onmousemove=mousemove_segmentratio;
      segment_inside_id.onmouseup=stopmove_segmentratio;
      mouse_status = mouse_segmentratio;
      ev.cancelBubble=true;
    }
  }
  return false;
}



/* Segment drawing */

function redraw_segment(a) {
  var t;

// Y

  if (a.Yend<a.Yinit) {
    var Xi=a.Xend;
    var Xe=a.Xinit;
    var Yi=a.Yend;
    var Ye=a.Yinit;
  }
  else {
    var Xe=a.Xend;
    var Xi=a.Xinit;
    var Ye=a.Yend;
    var Yi=a.Yinit;
  }

  var Ydelta=Ye-Yi;
  a.id.style.top=Yi;
  a.id.style.height=Ydelta;

  a.idN.style.height=a.topN;
  a.segname_id.style.top=(Yi+a.topN)-22;

// X

  if (Xi<Xe) {
    a.idN.style.borderLeftWidth=SegmentWidth;
    a.idN.style.borderRightWidth="0";
    a.idS.style.borderLeftWidth="0";
    a.idS.style.borderRightWidth=SegmentWidth;
  }
  else {
    a.idN.style.borderLeftWidth="0";
    a.idN.style.borderRightWidth=SegmentWidth;
    a.idS.style.borderLeftWidth=SegmentWidth;
    a.idS.style.borderRightWidth="0";
    t=Xe; Xe=Xi; Xi=t;
  }

  var Xdelta=Xe-Xi;
  a.id.style.left=Xi;
  a.id.style.width=Xdelta;
  a.segname_id.style.left=Xi+(Xdelta>>1)-20;
}

/* there is always one instance of a segment,
   ready to be displayed (like a "pre-fork") */
function new_segment_instance() {
  curSeg=new Object();

  /* create a new segment instance */
  curSeg.id=segment_id_orig.cloneNode(true);
  curSeg.CurrentSegmentName=SegmentPrefix+CurrentSegmentNumber;
  curSeg.id.id=curSeg.CurrentSegmentName;
  
  curSeg.idN=recurse_DOM("N",curSeg.id);
  curSeg.idS=recurse_DOM("S",curSeg.id);
  
  curSeg.segname_id=document.createElement("div");
  curSeg.segname_id.id=curSeg.CurrentSegmentName;
  curSeg.segname_id.innerHTML=curSeg.CurrentSegmentName;
  curSeg.segname_id.className="segname";

  curSeg.idN.style.border="solid "+SegmentDrawingColor+" 0px";
  curSeg.idS.style.border="solid "+SegmentDrawingColor+" 0px";
  curSeg.idN.style.borderBottomWidth=SegmentWidth;
}


/* (un)registration of a segment */

function remove_segment(ev) {
  var item=name_lookup(ev.target.id);
  hide_segment(item);
  add_history(item);
  return false;
}

function add_segment() {
  var newdiv=document.createElement("div");
  newdiv.id=curSeg.CurrentSegmentName;
  newdiv.className="itembar_item";

/* image  cliquer pour effacer le segment */
  var newimg=document.createElement("img");
  newimg.className="remove";
  newimg.src="erase.gif";
  newimg.onclick=remove_segment;
  newimg.id=curSeg.CurrentSegmentName;
  newimg.onmouseover = segment_mouseover;
  newimg.onmouseout  = segment_mouseover;
  newdiv.appendChild(newimg);
  curSeg.removeimg_id=newimg;

/* texte  cliquer pour accder aux proprits
   et qui est dans un <A> pour pouvoir le mettre en focus() */
  var newa=document.createElement("a");
  newa.id=curSeg.CurrentSegmentName;
  newa.className="segname";
  newa.onclick=function (ev) {alert("you just clicked on "+ev.target.id);};
  newa.onmouseover = segment_mouseover;
  newa.onmouseout  = segment_mouseover;
  newa.appendChild(document.createTextNode(curSeg.CurrentSegmentName));
  newdiv.appendChild(newa);
  curSeg.seglist_a=newa;

  newdiv.onmouseover = segment_mouseover;  /* highlight on hover */
  newdiv.onmouseout  = segment_mouseover;

  curSeg.segname_id.onmouseover = segment_mouseover;
  curSeg.segname_id.onmouseout  = segment_mouseover;
  curSeg.segname_id.onmousedown = startmove_segmentratio;

  curSeg.itembar_id=newdiv;
  curSeg.active=1;
  redraw_segment(curSeg);

  reverse_seglist[curSeg.CurrentSegmentName]=last_seg;
  segment_list[last_seg]=curSeg;

  display_segment(last_seg,1); // bypass
  add_history(last_seg);

  curSeg.idN.style.borderColor=curSeg.SegmentColor;
  curSeg.idS.style.borderColor=curSeg.SegmentColor;

  last_seg++;
  CurrentSegmentNumber++;
  new_segment_instance();
}

function adjust_segment_to_cursor(pageX, pageY) {
    curSeg.Xend = pageX - div_itembar_width;
    curSeg.Yend = pageY - div_menubar_height;
// Ce qui est embtant c'est que la barre horizontale du milieu
// est  50% au tout dbut, il faut faire le calcul du milieu ici,
// car redraw_segment() est aussi appel quand la barre a une hauteur
// dfinie par l'utilisateur.
    if (curSeg.Yend < curSeg.Yinit)
      curSeg.topN = (curSeg.Yinit - curSeg.Yend)>>1;
    else
      curSeg.topN = (curSeg.Yend - curSeg.Yinit)>>1;
}

function mouse_stop_segment(ev) {
  mouse_status = mouse_off;
  segment_inside_id.onmousemove=null;
  segment_inside_id.onmouseup=null;
  document.onkeyup=null;

// tester ici le type d'vnement

  if ( (dehautenbas && (mouse_yoffset<(ev.pageY - div_menubar_height)))
    || (debasenhaut && (mouse_yoffset>(ev.pageY - div_menubar_height)))) {
    /* validate and show */
    adjust_segment_to_cursor(ev.pageX, ev.pageY);
    add_segment();
  }
  else {
    segment_inside_id.removeChild(curSeg.segname_id);
    segment_inside_id.removeChild(curSeg.id);
  }
  return false;
}

//  mettre dans mouse_stop_segment
function key_stop_segment(ev) {
  if ((mouse_status==mouse_drawsegment) && (ev.keyCode==27)) { /* ESC key */
    mouse_stop_segment(ev);
    return false;
  }
}

function mouse_draw_segment(ev) {
  if ( (dehautenbas && (mouse_yoffset<(ev.pageY - div_menubar_height)))
    || (debasenhaut && (mouse_yoffset>(ev.pageY - div_menubar_height)))) {
    curSeg.idN.style.borderColor=SegmentDrawingColor;
    curSeg.idS.style.borderColor=SegmentDrawingColor;
    adjust_segment_to_cursor(ev.pageX, ev.pageY);
    redraw_segment(curSeg);
  }
  else {
    curSeg.idN.style.borderColor="#FF0000";
    curSeg.idS.style.borderColor="#FF0000";
  }
  return false;
}

function mouse_start_segment(ev) {
  if (mouse_status == mouse_off) {

// vrifier qu'on a bien cliqu sur la bonne zone
    if ( (ev.pageY < div_menubar_height) || (ev.pageX < div_itembar_width ) ) {
      window.console.info("coordonnes mauvaises, ya un bug qqpart !!!");
      return false;
    }

    mouse_status = mouse_drawsegment;

    mouse_xoffset = ev.pageX - div_itembar_width;
    mouse_yoffset = ev.pageY - div_menubar_height;

    curSeg.Xinit= mouse_xoffset;
    curSeg.Yinit= mouse_yoffset;
    curSeg.Xend = mouse_xoffset+SegmentWidth;
    curSeg.Yend = mouse_yoffset+SegmentWidth;
    curSeg.SegmentColor=origSegmentColor;

    curSeg.topN = 1; // hauteur minimale

    segment_inside_id.appendChild(curSeg.id);
    segment_inside_id.appendChild(curSeg.segname_id);
    redraw_segment(curSeg);

    segment_inside_id.onmousemove=mouse_draw_segment;
    segment_inside_id.onmouseup=mouse_stop_segment;
    document.onkeyup=key_stop_segment; // mouse_stop_segment  la place
  }
  return false;
}


/* init */

function init_segment() {
  segment_id_orig=document.getElementById('original_segment');
  segment_outside_id=document.getElementById('segment_outside_div');
  segment_inside_id=window.parent.segment_iframe.getElementById('segment_inside_div');
//document.getElementById('segment_inside_div');
//window.frames["segment_iframe"].window.getElementById('segment_inside_div');
  segment_inside_id.onmousedown=mouse_start_segment;
  new_segment_instance();
}
